<template>
  <div class="user-manage">
    <div class="part-box part-box-filter part-box-flex">
      <el-form ref="FilterForm" label-position="left" label-width="85px" inline>
        <el-form-item label="姓名：" label-width="75px">
          <el-input
            style="width: 142px;"
            v-model.trim="filter.realName"
            placeholder="请输入内容"
            clearable
          ></el-input>
        </el-form-item>
        <el-form-item label="启用/禁用：" label-width="90px">
          <el-select
            v-model="filter.enable"
            style="width: 142px;"
            placeholder="请选择"
            clearable
          >
            <el-option
              v-for="(val, key) in ABLE_TYPE"
              :key="key"
              :value="key * 1"
              :label="val"
            ></el-option>
          </el-select>
        </el-form-item>

        <el-form-item label-width="0px">
          <el-button type="primary" round @click="toPage(1)">查询</el-button>
        </el-form-item>
      </el-form>
      <div class="part-box-action">
        <el-button
          type="primary"
          icon="el-icon-circle-plus-outline"
          round
          @click="toAdd"
          >新增用户</el-button
        >
      </div>
    </div>

    <div class="part-box part-box-pad">
      <el-table ref="TableList" :data="users" border>
        <el-table-column
          type="index"
          label="序号"
          width="70"
          align="center"
          :index="indexMethod"
        ></el-table-column>
        <el-table-column prop="loginName" label="用户名"></el-table-column>
        <el-table-column prop="realName" label="姓名"></el-table-column>
        <el-table-column prop="roles" label="角色">
          <template slot-scope="scope">
            {{ scope.row.roles | rolesFilter }}
          </template>
        </el-table-column>
        <el-table-column prop="mobileNumber" label="手机号"></el-table-column>
        <el-table-column prop="enable" label="状态" width="100">
          <template slot-scope="scope">
            {{ scope.row.enable | enableFilter }}
          </template>
        </el-table-column>
        <el-table-column
          class-name="action-column"
          label="操作"
          align="center"
          width="120px"
        >
          <template slot-scope="scope">
            <el-button
              class="btn-table-icon"
              type="text"
              icon="icon icon-edit"
              @click="toEdit(scope.row)"
              title="编辑"
            ></el-button>
            <el-button
              class="btn-table-icon"
              type="text"
              :icon="
                scope.row.enable
                  ? 'icon icon-circle-stop'
                  : 'icon icon-circle-caret-right'
              "
              @click="toEnable(scope.row)"
              :title="scope.row.enable ? '禁用' : '启用'"
            ></el-button>
            <el-button
              class="btn-table-icon"
              type="text"
              icon="icon icon-circle-lock"
              @click="toResetPwd(scope.row)"
              title="重置密码"
            ></el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="part-page">
        <el-pagination
          background
          layout="total,prev, pager, next"
          :current-page="current"
          :total="total"
          :page-size="size"
          @current-change="toPage"
        >
        </el-pagination>
      </div>
    </div>

    <!-- ModifyUser -->
    <modify-user
      ref="ModifyUser"
      :instance="curUser"
      :roles="roles"
      @modified="getList"
    ></modify-user>
  </div>
</template>

<script>
import ModifyUser from "../components/ModifyUser";
import { ABLE_TYPE } from "@/constants/enumerate";
import { userListPage, ableUser, resetPwd, userRoleListPage } from "../api";

export default {
  name: "user-manage",
  components: { ModifyUser },
  data() {
    return {
      filter: {
        realName: "",
        enable: ""
      },
      current: 1,
      size: this.GLOBAL.pageSize,
      total: 0,
      visible: false,
      ABLE_TYPE,
      roles: [],
      users: [],
      curUser: {}
    };
  },
  created() {
    this.getRoleList();
    this.getList();
  },
  methods: {
    async getRoleList() {
      const data = await userRoleListPage();
      this.roles = data || [];
      this.roles = this.roles
        .filter(item => item.type === "CUSTOMER")
        .map(item => {
          return {
            id: item.id,
            name: item.name,
            type: item.type
          };
        });
      console.log(this.roles);
    },
    async getList() {
      const datas = {
        ...this.filter,
        pageNumber: this.current,
        pageSize: this.size
      };
      if (datas.enable !== null && datas.enable !== "")
        datas.enable = !!datas.enable;
      const data = await userListPage(datas);
      this.users = data.records;
      this.total = data.total;
    },
    toPage(page) {
      this.current = page;
      this.getList();
    },
    toEnable(row) {
      // 自己不可以启用/禁用自己
      const userId = this.$ls.get("user", { id: "" }).id;
      if (row.id === userId) {
        this.$message.error("不可以启用/禁用自己！");
        return;
      }

      const action = row.enable ? "禁用" : "启用";
      this.$confirm(`确定要${action}用户【${row.realName}】吗?`, "提示", {
        cancelButtonClass: "el-button--danger is-plain",
        confirmButtonClass: "el-button--primary",
        type: "warning"
      })
        .then(async () => {
          const enable = !row.enable;
          await ableUser({
            id: row.id,
            enable
          });
          row.enable = enable;
          this.$message.success("操作成功！");
        })
        .catch(() => {});
    },
    toEdit(row) {
      this.curUser = row;
      this.$refs.ModifyUser.open();
    },
    toAdd() {
      this.curUser = {
        roles: this.roles
      };
      this.$refs.ModifyUser.open();
    },
    async toResetPwd(row) {
      await resetPwd(row.id);
      this.$message.success("密码重置成功！");
    }
  }
};
</script>
